Index: branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/OPA_SRC/LDF/ldfslp_crs.F90
===================================================================
--- branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/OPA_SRC/LDF/ldfslp_crs.F90	(revision 5588)
+++ branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/OPA_SRC/LDF/ldfslp_crs.F90	(revision 5601)
@@ -21,6 +21,6 @@
    !!   ldf_slp_init : initialization of the slopes computation
    !!----------------------------------------------------------------------
-   USE oce             ! ocean dynamics and tracers
- !  USE dom_oce         ! ocean space and time domain
+   !USE oce             ! ocean dynamics and tracers
+   !USE dom_oce         ! ocean space and time domain
    USE ldftra_oce      ! lateral diffusion: traceur
    USE ldfdyn_oce      ! lateral diffusion: dynamics
@@ -34,4 +34,5 @@
    USE timing          ! Timing
    USE crs
+   USE iom
 
    IMPLICIT NONE
@@ -45,6 +46,4 @@
    !                                                                             !! Madec operator
    !  Arrays allocated in ldf_slp_init() routine once we know whether we're using the Griffies or Madec operator
-   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:)     ::   uslp_crs, wslpi_crs          !: i_slope at U- and W-points
-   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:)     ::   vslp_crs, wslpj_crs          !: j-slope at V- and W-points
    !                                                                !! Griffies operator
    REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:)     ::   wslp2                !: wslp**2 from Griffies quarter cells
@@ -113,5 +112,5 @@
       !!----------------------------------------------------------------------
       !
-      IF( nn_timing == 1 )  CALL timing_start('ldf_slp')
+      IF( nn_timing == 1 )  CALL timing_start('ldf_slp_crs')
       !
       CALL wrk_alloc( jpi_crs,jpj_crs,jpk, zwz, zww, zdzr, zgru, zgrv )
@@ -126,6 +125,6 @@
       !
       DO jk = 1, jpk             !==   i- & j-gradient of density   ==!
-         DO jj = 1, jpjm1
-            DO ji = 1, fs_jpim1   ! vector opt.
+         DO jj = 1, jpj_crsm1
+            DO ji = 1, jpi_crsm1   ! vector opt.
                zgru(ji,jj,jk) = umask_crs(ji,jj,jk) * ( prd(ji+1,jj  ,jk) - prd(ji,jj,jk) )
                zgrv(ji,jj,jk) = vmask_crs(ji,jj,jk) * ( prd(ji  ,jj+1,jk) - prd(ji,jj,jk) )
@@ -134,11 +133,6 @@
       END DO
       IF( ln_zps ) THEN                           ! partial steps correction at the bottom ocean level
-# if defined key_vectopt_loop
-         DO jj = 1, 1
-            DO ji = 1, jpij-jpi   ! vector opt. (forced unrolling)
-# else
-         DO jj = 1, jpjm1
-            DO ji = 1, jpim1
-# endif
+         DO jj = 1, jpj_crsm1
+            DO ji = 1, jpi_crsm1
                zgru(ji,jj,mbku_crs(ji,jj)) = gru_crs(ji,jj)
                zgrv(ji,jj,mbkv_crs(ji,jj)) = grv_crs(ji,jj)
@@ -146,14 +140,12 @@
          END DO
       ENDIF
-!WRITE(numout,*) ' zgrv (ji,jj,jk-1)' , zgrv (:,:,:)
-!WRITE(numout,*) ' grv_crs (ji,jj,jk-1)'  ,grv_crs (:,:)
       !
       zdzr(:,:,1) = 0._wp        !==   Local vertical density gradient at T-point   == !   (evaluated from N^2)
       DO jk = 2, jpkm1
          !                               !   trick: tmask(ik  )  = 0   =>   all pn2   = 0   =>   zdzr = 0
-         !                                !    else  tmask(ik+1)  = 0   =>   pn2(ik+1) = 0   =>   zdzr divides by 1
-         !                                    ! zdzr = d/dz(prd)= - ( prd ) / grav * mk(pn2) -- at t point
-         !                             !          umask(ik+1) /= 0   =>   all pn2  /= 0   =>   zdzr divides by 2
-         !                                ! NB: 1/(tmask+1) = (1-.5*tmask)  substitute a / by a *  ==> faster
+         !                               !    else  tmask(ik+1)  = 0   =>   pn2(ik+1) = 0   =>   zdzr divides by 1
+         !                               ! zdzr = d/dz(prd)= - ( prd ) / grav * mk(pn2) -- at t point
+         !                               !          umask(ik+1) /= 0   =>   all pn2  /= 0   =>   zdzr divides by 2
+         !                               ! NB: 1/(tmask+1) = (1-.5*tmask)  substitute a / by a *  ==> faster
          zdzr(:,:,jk) = zm1_g * ( prd(:,:,jk) + 1._wp )              &
             &                 * ( pn2(:,:,jk) + pn2(:,:,jk+1) ) * ( 1._wp - 0.5_wp * tmask_crs(:,:,jk+1) )
@@ -163,11 +155,10 @@
       CALL ldf_slp_mxl_crs( prd, pn2, zgru, zgrv, zdzr )        ! output: uslpml, vslpml, wslpiml, wslpjml
 
-
       ! I.  slopes at u and v point      | uslp = d/di( prd ) / d/dz( prd )
       ! ===========================      | vslp = d/dj( prd ) / d/dz( prd )
       !
       DO jk = 2, jpkm1                            !* Slopes at u and v points
-         DO jj = 2, jpjm1
-            DO ji = fs_2, fs_jpim1   ! vector opt.
+         DO jj = 2, jpj_crsm1
+            DO ji = 2, jpi_crsm1   ! vector opt.
                !                                      ! horizontal and vertical density gradient at u- and v-points
                zau = zgru(ji,jj,jk) / e1u_crs(ji,jj)
@@ -177,13 +168,8 @@
                !                                      ! bound the slopes: abs(zw.)<= 1/100 and zb..<0
                !                                      ! + kxz max= ah slope max =< e1 e3 /(pi**2 2 dt)
-     !IF( umask_crs(ji,jj,jk) .NE. 0._wp .AND. e3u_max_crs(ji,jj,jk)==0._wp )WRITE(narea+3000,*)"bug zbu ",umask_crs(ji,jj,jk),e3u_max_crs(ji,jj,jk) ; CALL flush(narea+3000)
-     !IF( e3u_max_crs(ji,jj,jk)==0._wp )WRITE(narea+3000,*)"bug zbu1 ",ji,jj,jk,umask_crs(ji,jj,jk),e3u_max_crs(ji,jj,jk) ; CALL flush(narea+3000)
                zbu = MIN(  zbu, -100._wp* ABS( zau ) , -7.e+3_wp/e3u_max_crs(ji,jj,jk)* ABS( zau )  )
                zbv = MIN(  zbv, -100._wp* ABS( zav ) , -7.e+3_wp/e3v_max_crs(ji,jj,jk)* ABS( zav )  )
-                  
-!cc               zbu = MIN(  zbu, -100._wp* ABS( zau ) , -7.e+3_wp/e3u_crs(ji,jj,jk)* ABS( zau )  )
-!cc               zbv = MIN(  zbv, -100._wp* ABS( zav ) , -7.e+3_wp/e3v_crs(ji,jj,jk)* ABS( zav )  )
-
-
+               !cc zbu = MIN(  zbu, -100._wp* ABS( zau ) , -7.e+3_wp/e3u_crs(ji,jj,jk)* ABS( zau )  )
+               !cc zbv = MIN(  zbv, -100._wp* ABS( zav ) , -7.e+3_wp/e3v_crs(ji,jj,jk)* ABS( zav )  )
                !                                      ! uslp and vslp output in zwz and zww, resp.
                zfi = MAX( omlmask(ji,jj,jk), omlmask(ji+1,jj,jk) )
@@ -210,9 +196,11 @@
       END DO
       CALL crs_lbc_lnk( zwz, 'U', -1. )   ;   CALL crs_lbc_lnk( zww, 'V', -1. )      ! lateral boundary conditions
+      CALL iom_put("zwz_crs",zwz)
+      CALL iom_put("zww_crs",zww)
       !
       !                                            !* horizontal Shapiro filter
       DO jk = 2, jpkm1
-         DO jj = 2, jpjm1, MAX(1, jpj-3)                        ! rows jj=2 and =jpjm1 only
-            DO ji = 2, jpim1
+         DO jj = 2, jpj_crsm1, MAX(1, jpj_crs-3)                        ! rows jj=2 and =jpjm1 only
+            DO ji = 2, jpi_crsm1
                uslp_crs(ji,jj,jk) = z1_16 * (        zwz(ji-1,jj-1,jk) + zwz(ji+1,jj-1,jk)      &
                   &                       +      zwz(ji-1,jj+1,jk) + zwz(ji+1,jj+1,jk)      &
@@ -227,6 +215,6 @@
             END DO
          END DO
-         DO jj = 3, jpj-2                               ! other rows
-            DO ji = fs_2, fs_jpim1   ! vector opt.
+         DO jj = 3, jpj_crs-2                               ! other rows
+            DO ji = 2, jpi_crsm1   ! vector opt.
                uslp_crs(ji,jj,jk) = z1_16 * (        zwz(ji-1,jj-1,jk) + zwz(ji+1,jj-1,jk)      &
                   &                       +      zwz(ji-1,jj+1,jk) + zwz(ji+1,jj+1,jk)      &
@@ -242,6 +230,6 @@
          END DO
          !                                        !* decrease along coastal boundaries
-         DO jj = 2, jpjm1
-            DO ji = fs_2, fs_jpim1   ! vector opt.
+         DO jj = 2, jpj_crsm1
+            DO ji = 2, jpi_crsm1   ! vector opt.
                uslp_crs(ji,jj,jk) = uslp_crs(ji,jj,jk) * ( umask_crs(ji,jj+1,jk) + umask_crs(ji,jj-1,jk  ) ) * 0.5_wp   &
                   &                            * ( umask_crs(ji,jj  ,jk) + umask_crs(ji,jj  ,jk+1) ) * 0.5_wp
@@ -257,6 +245,6 @@
       !
       DO jk = 2, jpkm1
-         DO jj = 2, jpjm1
-            DO ji = fs_2, fs_jpim1   ! vector opt.
+         DO jj = 2, jpj_crsm1
+            DO ji = 2, jpi_crsm1   ! vector opt.
                !                                  !* Local vertical density gradient evaluated from N^2
                zbw = zm1_2g * pn2 (ji,jj,jk) * ( prd (ji,jj,jk) + prd (ji,jj,jk-1) + 2. )
@@ -281,10 +269,4 @@
                zwz(ji,jj,jk) = (  zai / ( zbi - zeps ) * ( 1._wp - zfk ) + zck * wslpiml(ji,jj) * zfk  ) * tmask_crs(ji,jj,jk)
                zww(ji,jj,jk) = (  zaj / ( zbj - zeps ) * ( 1._wp - zfk ) + zck * wslpjml(ji,jj) * zfk  ) * tmask_crs(ji,jj,jk)
-!WRITE(numout,*) ' wslpiml(ji,jj)' , wslpiml(ji,jj)
-!WRITE(numout,*) ' zbj' , zbj
-!WRITE(numout,*) ' zeps' , zeps
-!WRITE(numout,*) ' zaj' , zaj
-
-
 !!gm  modif to suppress omlmask....  (as in Griffies operator)
 !               !                                         ! jk must be >= ML level for zfk=1. otherwise  zfk=0.
@@ -301,6 +283,6 @@
       !                                           !* horizontal Shapiro filter
       DO jk = 2, jpkm1
-         DO jj = 2, jpjm1, MAX(1, jpj-3)                        ! rows jj=2 and =jpjm1 only
-            DO ji = 2, jpim1
+         DO jj = 2, jpj_crsm1, MAX(1, jpj-3)                        ! rows jj=2 and =jpjm1 only
+            DO ji = 2, jpi_crsm1
                zcofw = tmask_crs(ji,jj,jk) * z1_16
                wslpi_crs(ji,jj,jk) = (      zwz(ji-1,jj-1,jk) + zwz(ji+1,jj-1,jk)     &
@@ -317,6 +299,6 @@
             END DO
          END DO
-         DO jj = 3, jpj-2                               ! other rows
-            DO ji = fs_2, fs_jpim1   ! vector opt.
+         DO jj = 3, jpj_crs-2                               ! other rows
+            DO ji = 2, jpi_crsm1   ! vector opt.
                zcofw = tmask_crs(ji,jj,jk) * z1_16
                wslpi_crs(ji,jj,jk) = (      zwz(ji-1,jj-1,jk) + zwz(ji+1,jj-1,jk)     &
@@ -334,6 +316,6 @@
          END DO
          !                                        !* decrease along coastal boundaries
-         DO jj = 2, jpjm1
-            DO ji = fs_2, fs_jpim1   ! vector opt.
+         DO jj = 2, jpj_crsm1
+            DO ji = 2, jpi_crsm1   ! vector opt.
                zck =   ( umask_crs(ji,jj,jk) + umask_crs(ji-1,jj,jk) )   &
                   &  * ( vmask_crs(ji,jj,jk) + vmask_crs(ji,jj-1,jk) ) * 0.25
@@ -344,281 +326,25 @@
       END DO
 
-      ! III.  Specific grid points
-      ! ===========================
- !! cc     !
- !     IF( cp_cfg == "orca" .AND. jp_cfg == 4 ) THEN     !  ORCA_R4 configuration: horizontal diffusion in specific area
- !        !                                                    ! Gibraltar Strait
- !        ij0 =  50   ;   ij1 =  53
- !        ii0 =  69   ;   ii1 =  71   ;   uslp ( mi0(ii0):mi1(ii1) , mj0(ij0):mj1(ij1) , : ) = 0._wp
- !        ij0 =  51   ;   ij1 =  53
- !        ii0 =  68   ;   ii1 =  71   ;   vslp ( mi0(ii0):mi1(ii1) , mj0(ij0):mj1(ij1) , : ) = 0._wp
- !        ii0 =  69   ;   ii1 =  71   ;   wslpi( mi0(ii0):mi1(ii1) , mj0(ij0):mj1(ij1) , : ) = 0._wp
- !        ii0 =  69   ;   ii1 =  71   ;   wslpj( mi0(ii0):mi1(ii1) , mj0(ij0):mj1(ij1) , : ) = 0._wp
- !        !
- !        !                                                    ! Mediterrannean Sea
- !        ij0 =  49   ;   ij1 =  56
- !        ii0 =  71   ;   ii1 =  90   ;   uslp ( mi0(ii0):mi1(ii1) , mj0(ij0):mj1(ij1) , : ) = 0._wp
- !        ij0 =  50   ;   ij1 =  56
- !        ii0 =  70   ;   ii1 =  90   ;   vslp ( mi0(ii0):mi1(ii1) , mj0(ij0):mj1(ij1) , : ) = 0._wp
- !        ii0 =  71   ;   ii1 =  90   ;   wslpi( mi0(ii0):mi1(ii1) , mj0(ij0):mj1(ij1) , : ) = 0._wp
- !        ii0 =  71   ;   ii1 =  90   ;   wslpj( mi0(ii0):mi1(ii1) , mj0(ij0):mj1(ij1) , : ) = 0._wp
- !     ENDIF
-!! cc
-
       ! IV. Lateral boundary conditions
       ! ===============================
-      CALL crs_lbc_lnk( uslp_crs , 'U', -1. )      ;      CALL crs_lbc_lnk( vslp_crs , 'V', -1. )
+      CALL crs_lbc_lnk( uslp_crs , 'U', -1. )      
+      CALL crs_lbc_lnk( vslp_crs , 'V', -1. )
       CALL crs_lbc_lnk( wslpi_crs, 'W', -1. )      ;      CALL crs_lbc_lnk( wslpj_crs, 'W', -1. )
-!WRITE(numout,*) ' zww' , zww(:,:,:)
-!WRITE(numout,*) ' wslpj_crs' , wslpj_crs(:,:,:)
-  !    IF(ln_ctl) THEN
-  !       CALL prt_ctl(tab3d_1=uslp , clinfo1=' slp  - u : ', tab3d_2=vslp,  clinfo2=' v : ', kdim=jpk)
-  !      CALL prt_ctl(tab3d_1=wslpi, clinfo1=' slp  - wi: ', tab3d_2=wslpj, clinfo2=' wj: ', kdim=jpk)
-  !    ENDIF
-      !
-      CALL wrk_dealloc( jpi,jpj,jpk, zwz, zww, zdzr, zgru, zgrv )
-      !
-      IF( nn_timing == 1 )  CALL timing_stop('ldf_slp')
+      !
+      CALL iom_swap( "nemo_crs" )    ! swap on the coarse grid
+      CALL iom_put("zgru_crs",zgru)
+      CALL iom_put("zgrv_crs",zgrv)
+      CALL iom_put("zdzr_crs",zdzr)
+      CALL iom_put("zwz_crs",zwz)
+      CALL iom_put("zww_crs",zww)
+      CALL iom_put("uslp_crs",uslp_crs)
+      CALL iom_put("vslp_crs",vslp_crs)
+      CALL iom_swap( "nemo" )    ! swap on the coarse grid
+      !
+      CALL wrk_dealloc( jpi_crs,jpj_crs,jpk, zwz, zww, zdzr, zgru, zgrv )
+      !
+      IF( nn_timing == 1 )  CALL timing_stop('ldf_slp_crs')
       !
    END SUBROUTINE ldf_slp_crs
-
-
-   SUBROUTINE ldf_slp_grif_crs ( kt )
-      !!----------------------------------------------------------------------
-      !!                 ***  ROUTINE ldf_slp_grif  ***
-      !!
-      !! ** Purpose :   Compute the squared slopes of neutral surfaces (slope
-      !!      of iso-pycnal surfaces referenced locally) (ln_traldf_grif=T)
-      !!      at W-points using the Griffies quarter-cells.
-      !!
-      !! ** Method  :   calculates alpha and beta at T-points
-      !!
-      !! ** Action : - triadi_g, triadj_g   T-pts i- and j-slope triads relative to geopot. (used for eiv)
-      !!             - triadi , triadj    T-pts i- and j-slope triads relative to model-coordinate
-      !!             - wslp2              squared slope of neutral surfaces at w-points.
-      !!----------------------------------------------------------------------
-      INTEGER, INTENT( in ) ::   kt             ! ocean time-step index
-      !!
-      INTEGER  ::   ji, jj, jk, jl, ip, jp, kp  ! dummy loop indices
-      INTEGER  ::   iku, ikv                    ! local integer
-      REAL(wp) ::   zfacti, zfactj              ! local scalars
-      REAL(wp) ::   znot_thru_surface           ! local scalars
-      REAL(wp) ::   zdit, zdis, zdjt, zdjs, zdkt, zdks, zbu, zbv, zbti, zbtj
-      REAL(wp) ::   zdxrho_raw, zti_coord, zti_raw, zti_lim, zti_g_raw, zti_g_lim
-      REAL(wp) ::   zdyrho_raw, ztj_coord, ztj_raw, ztj_lim, ztj_g_raw, ztj_g_lim
-      REAL(wp) ::   zdzrho_raw
-      REAL(wp) ::   zbeta0
-      REAL(wp), POINTER, DIMENSION(:,:)     ::   z1_mlbw
-      REAL(wp), POINTER, DIMENSION(:,:,:)   ::   zalbet
-      REAL(wp), POINTER, DIMENSION(:,:,:,:) ::   zdxrho , zdyrho, zdzrho     ! Horizontal and vertical density gradients
-      REAL(wp), POINTER, DIMENSION(:,:,:,:) ::   zti_mlb, ztj_mlb            ! for Griffies operator only
-      !!----------------------------------------------------------------------
-      !
-      IF( nn_timing == 1 )  CALL timing_start('ldf_slp_grif')
-      !
-      CALL wrk_alloc( jpi,jpj, z1_mlbw )
-      CALL wrk_alloc( jpi,jpj,jpk, zalbet )
-      CALL wrk_alloc( jpi,jpj,jpk,2, zdxrho , zdyrho, zdzrho,              klstart = 0  )
-      CALL wrk_alloc( jpi,jpj,  2,2, zti_mlb, ztj_mlb,        kkstart = 0, klstart = 0  )
-      !
-      !--------------------------------!
-      !  Some preliminary calculation  !
-      !--------------------------------!
-      !
-      CALL eos_alpbet_crs( tsb_crs, zalbet, zbeta0 )  !==  before local thermal/haline expension ratio at T-points  ==!
-      !
-      DO jl = 0, 1                            !==  unmasked before density i- j-, k-gradients  ==!
-         !
-         ip = jl   ;   jp = jl                ! guaranteed nonzero gradients ( absolute value larger than repsln)
-         DO jk = 1, jpkm1                     ! done each pair of triad
-            DO jj = 1, jpjm1                  ! NB: not masked ==>  a minimum value is set
-               DO ji = 1, fs_jpim1            ! vector opt.
-                  zdit = ( tsb(ji+1,jj,jk,jp_tem) - tsb(ji,jj,jk,jp_tem) )    ! i-gradient of T & S at u-point
-                  zdis = ( tsb(ji+1,jj,jk,jp_sal) - tsb(ji,jj,jk,jp_sal) )
-                  zdjt = ( tsb(ji,jj+1,jk,jp_tem) - tsb(ji,jj,jk,jp_tem) )    ! j-gradient of T & S at v-point
-                  zdjs = ( tsb(ji,jj+1,jk,jp_sal) - tsb(ji,jj,jk,jp_sal) )
-                  zdxrho_raw = ( - zalbet(ji+ip,jj   ,jk) * zdit + zbeta0*zdis ) / e1u(ji,jj)
-                  zdyrho_raw = ( - zalbet(ji   ,jj+jp,jk) * zdjt + zbeta0*zdjs ) / e2v(ji,jj)
-                  zdxrho(ji+ip,jj   ,jk,1-ip) = SIGN( MAX(   repsln, ABS( zdxrho_raw ) ), zdxrho_raw )   ! keep the sign
-                  zdyrho(ji   ,jj+jp,jk,1-jp) = SIGN( MAX( repsln, ABS( zdyrho_raw ) ), zdyrho_raw )
-               END DO
-            END DO
-         END DO
-         !
-         IF( ln_zps.and.l_grad_zps ) THEN     ! partial steps: correction of i- & j-grad on bottom
-# if defined key_vectopt_loop
-            DO jj = 1, 1
-               DO ji = 1, jpij-jpi            ! vector opt. (forced unrolling)
-# else
-            DO jj = 1, jpjm1
-               DO ji = 1, jpim1
-# endif
-                  iku  = mbku_crs(ji,jj)          ;   ikv  = mbkv_crs(ji,jj)             ! last ocean level (u- & v-points)
-                  zdit = gtsu_crs(ji,jj,jp_tem)   ;   zdjt = gtsv_crs(ji,jj,jp_tem)      ! i- & j-gradient of Temperature
-                  zdis = gtsu_crs(ji,jj,jp_sal)   ;   zdjs = gtsv_crs(ji,jj,jp_sal)      ! i- & j-gradient of Salinity
-                  zdxrho_raw = ( - zalbet(ji+ip,jj   ,iku) * zdit + zbeta0*zdis ) / e1u(ji,jj)
-                  zdyrho_raw = ( - zalbet(ji   ,jj+jp,ikv) * zdjt + zbeta0*zdjs ) / e2v(ji,jj)
-                  zdxrho(ji+ip,jj   ,iku,1-ip) = SIGN( MAX( repsln, ABS( zdxrho_raw ) ), zdxrho_raw )   ! keep the sign
-                  zdyrho(ji   ,jj+jp,ikv,1-jp) = SIGN( MAX( repsln, ABS( zdyrho_raw ) ), zdyrho_raw )
-               END DO
-            END DO
-         ENDIF
-         !
-      END DO
-
-      DO kp = 0, 1                            !==  unmasked before density i- j-, k-gradients  ==!
-         DO jk = 1, jpkm1                     ! done each pair of triad
-            DO jj = 1, jpj                    ! NB: not masked ==>  a minimum value is set
-               DO ji = 1, jpi                 ! vector opt.
-                  IF( jk+kp > 1 ) THEN        ! k-gradient of T & S a jk+kp
-                     zdkt = ( tsb(ji,jj,jk+kp-1,jp_tem) - tsb(ji,jj,jk+kp,jp_tem) )
-                     zdks = ( tsb(ji,jj,jk+kp-1,jp_sal) - tsb(ji,jj,jk+kp,jp_sal) )
-                  ELSE
-                     zdkt = 0._wp                                             ! 1st level gradient set to zero
-                     zdks = 0._wp
-                  ENDIF
-                  zdzrho_raw = ( - zalbet(ji   ,jj   ,jk) * zdkt + zbeta0*zdks ) / fse3w(ji,jj,jk+kp)
-                  zdzrho(ji   ,jj   ,jk,  kp) =     - MIN( - repsln,      zdzrho_raw )    ! force zdzrho >= repsln
-                 END DO
-            END DO
-         END DO
-      END DO
-      !
-      DO jj = 1, jpj                          !==  Reciprocal depth of the w-point below ML base  ==!
-         DO ji = 1, jpi
-            jk = MIN( nmln_crs(ji,jj), mbkt_crs(ji,jj) ) + 1     ! MIN in case ML depth is the ocean depth
-            z1_mlbw(ji,jj) = 1._wp / gdepw_crs(ji,jj,jk)
-         END DO
-      END DO
-      !
-      !                                       !==  intialisations to zero  ==!
-      !
-      wslp2  (:,:,:)     = 0._wp              ! wslp2 will be cumulated 3D field set to zero
-      triadi_g(:,:,1,:,:) = 0._wp   ;   triadi_g(:,:,jpk,:,:) = 0._wp   ! set surface and bottom slope to zero
-      triadj_g(:,:,1,:,:) = 0._wp   ;   triadj_g(:,:,jpk,:,:) = 0._wp
-      !!gm _iso set to zero missing
-      triadi  (:,:,1,:,:) = 0._wp   ;   triadj  (:,:,jpk,:,:) = 0._wp   ! set surface and bottom slope to zero
-      triadj  (:,:,1,:,:) = 0._wp   ;   triadj  (:,:,jpk,:,:) = 0._wp
-
-      !-------------------------------------!
-      !  Triads just below the Mixed Layer  !
-      !-------------------------------------!
-      !
-      DO jl = 0, 1                            ! calculate slope of the 4 triads immediately ONE level below mixed-layer base
-         DO kp = 0, 1                         ! with only the slope-max limit   and   MASKED
-            DO jj = 1, jpjm1
-               DO ji = 1, fs_jpim1
-                  ip = jl   ;   jp = jl
-                  jk = MIN( nmln_crs(ji+ip,jj) , mbkt_crs(ji+ip,jj) ) + 1         ! ML level+1 (MIN in case ML depth is the ocean depth)
-                  ! Add s-coordinate slope at t-points (do this by *subtracting* gradient of depth)
-                  zti_g_raw = (  zdxrho(ji+ip,jj,jk-kp,1-ip) / zdzrho(ji+ip,jj,jk-kp,kp)      &
-                     &      - ( gdept_crs(ji+1,jj,jk-kp) - gdept_crs(ji,jj,jk-kp) ) / e1u_crs(ji,jj)  ) * umask_crs(ji,jj,jk)
-                  jk = MIN( nmln_crs(ji,jj+jp) , mbkt_crs(ji,jj+jp) ) + 1
-                  ztj_g_raw = (  zdyrho(ji,jj+jp,jk-kp,1-jp) / zdzrho(ji,jj+jp,jk-kp,kp)      &
-                     &      - ( gdept_crs(ji,jj+1,jk-kp) - gdept_crs(ji,jj,jk-kp) ) / e2v_crs(ji,jj)  ) * vmask_crs(ji,jj,jk)
-                  zti_mlb(ji+ip,jj   ,1-ip,kp) = SIGN( MIN( rn_slpmax, ABS( zti_g_raw ) ), zti_g_raw )
-                  ztj_mlb(ji   ,jj+jp,1-jp,kp) = SIGN( MIN( rn_slpmax, ABS( ztj_g_raw ) ), ztj_g_raw )
-               END DO
-            END DO
-         END DO
-      END DO
-
-      !-------------------------------------!
-      !  Triads with surface limits         !
-      !-------------------------------------!
-      !
-      DO kp = 0, 1                            ! k-index of triads
-         DO jl = 0, 1
-            ip = jl   ;   jp = jl             ! i- and j-indices of triads (i-k and j-k planes)
-            DO jk = 1, jpkm1
-               ! Must mask contribution to slope from dz/dx at constant s for triads jk=1,kp=0 that poke up though ocean surface
-               znot_thru_surface = REAL( 1-1/(jk+kp), wp )  !jk+kp=1,=0.; otherwise=1.0
-               DO jj = 1, jpjm1
-                  DO ji = 1, fs_jpim1         ! vector opt.
-                     !
-                     ! Calculate slope relative to geopotentials used for GM skew fluxes
-                     ! Add s-coordinate slope at t-points (do this by *subtracting* gradient of depth)
-                     ! Limit by slope *relative to geopotentials* by rn_slpmax, and mask by psi-point
-                     ! masked by umask taken at the level of dz(rho)
-                     !
-                     ! raw slopes: unmasked unbounded slopes (relative to geopotential (zti_g) and model surface (zti)
-                     !
-                     zti_raw   = zdxrho(ji+ip,jj   ,jk,1-ip) / zdzrho(ji+ip,jj   ,jk,kp)                   ! unmasked
-                     ztj_raw   = zdyrho(ji   ,jj+jp,jk,1-jp) / zdzrho(ji   ,jj+jp,jk,kp)
-
-                     ! Must mask contribution to slope for triad jk=1,kp=0 that poke up though ocean surface
-                     zti_coord = znot_thru_surface * ( gdept_crs(ji+1,jj  ,jk) - gdept_crs(ji,jj,jk) ) / e1u_crs(ji,jj)
-                     ztj_coord = znot_thru_surface * ( gdept_crs(ji  ,jj+1,jk) - gdept_crs(ji,jj,jk) ) / e2v_crs(ji,jj)                  ! unmasked
-                     zti_g_raw = zti_raw - zti_coord      ! ref to geopot surfaces
-                     ztj_g_raw = ztj_raw - ztj_coord
-                     zti_g_lim = SIGN( MIN( rn_slpmax, ABS( zti_g_raw ) ), zti_g_raw )
-                     ztj_g_lim = SIGN( MIN( rn_slpmax, ABS( ztj_g_raw ) ), ztj_g_raw )
-                     !
-                     ! Below  ML use limited zti_g as is & mask
-                     ! Inside ML replace by linearly reducing sx_mlb towards surface & mask
-                     !
-                     zfacti = REAL( 1 - 1/(1 + (jk+kp-1)/nmln_crs(ji+ip,jj)), wp )  ! k index of uppermost point(s) of triad is jk+kp-1
-                     zfactj = REAL( 1 - 1/(1 + (jk+kp-1)/nmln_crs(ji,jj+jp)), wp )  ! must be .ge. nmln(ji,jj) for zfact=1
-                     !                                                          !                   otherwise  zfact=0
-                     zti_g_lim =          ( zfacti   * zti_g_lim                       &
-                        &      + ( 1._wp - zfacti ) * zti_mlb(ji+ip,jj,1-ip,kp)   &
-                        &                           * fsdepw(ji+ip,jj,jk+kp) * z1_mlbw(ji+ip,jj) ) * umask_crs(ji,jj,jk+kp)
-                     ztj_g_lim =          ( zfactj   * ztj_g_lim                       &
-                        &      + ( 1._wp - zfactj ) * ztj_mlb(ji,jj+jp,1-jp,kp)   &
-                        &                           * fsdepw(ji,jj+jp,jk+kp) * z1_mlbw(ji,jj+jp) ) * vmask_crs(ji,jj,jk+kp)
-                     !
-                     triadi_g(ji+ip,jj   ,jk,1-ip,kp) = zti_g_lim
-                     triadj_g(ji   ,jj+jp,jk,1-jp,kp) = ztj_g_lim
-                     !
-                     ! Get coefficients of isoneutral diffusion tensor
-                     ! 1. Utilise gradients *relative* to s-coordinate, so add t-point slopes (*subtract* depth gradients)
-                     ! 2. We require that isoneutral diffusion  gives no vertical buoyancy flux
-                     !     i.e. 33 term = (real slope* 31, 13 terms)
-                     ! To do this, retain limited sx**2  in vertical flux, but divide by real slope for 13/31 terms
-                     ! Equivalent to tapering A_iso = sx_limited**2/(real slope)**2
-                     !
-                     zti_lim  = ( zti_g_lim + zti_coord ) * umask_crs(ji,jj,jk+kp)    ! remove coordinate slope => relative to coordinate surfaces
-                     ztj_lim  = ( ztj_g_lim + ztj_coord ) * vmask_crs(ji,jj,jk+kp)
-                     !
-                     IF( ln_triad_iso ) THEN
-                        zti_raw = zti_lim**2 / zti_raw
-                        ztj_raw = ztj_lim**2 / ztj_raw
-                        zti_raw = SIGN( MIN( ABS(zti_lim), ABS( zti_raw ) ), zti_raw )
-                        ztj_raw = SIGN( MIN( ABS(ztj_lim), ABS( ztj_raw ) ), ztj_raw )
-                        zti_lim =           zfacti   * zti_lim                       &
-                        &      + ( 1._wp - zfacti ) * zti_raw
-                        ztj_lim =           zfactj   * ztj_lim                       &
-                        &      + ( 1._wp - zfactj ) * ztj_raw
-                     ENDIF
-                     triadi(ji+ip,jj   ,jk,1-ip,kp) = zti_lim
-                     triadj(ji   ,jj+jp,jk,1-jp,kp) = ztj_lim
-                    !
-                     zbu = e1u(ji    ,jj) * e2u(ji   ,jj) * fse3u(ji   ,jj,jk   )
-                     zbv = e1v(ji    ,jj) * e2v(ji   ,jj) * fse3v(ji   ,jj,jk   )
-                     zbti = e1t(ji+ip,jj) * e2t(ji+ip,jj) * fse3w(ji+ip,jj,jk+kp)
-                     zbtj = e1t(ji,jj+jp) * e2t(ji,jj+jp) * fse3w(ji,jj+jp,jk+kp)
-                     !
-                     !!gm this may inhibit vectorization on Vect Computers, and even on scalar computers....  ==> to be checked
-                     wslp2 (ji+ip,jj,jk+kp) = wslp2(ji+ip,jj,jk+kp) + 0.25_wp * zbu / zbti * zti_g_lim**2      ! masked
-                     wslp2 (ji,jj+jp,jk+kp) = wslp2(ji,jj+jp,jk+kp) + 0.25_wp * zbv / zbtj * ztj_g_lim**2
-                  END DO
-               END DO
-            END DO
-         END DO
-      END DO
-      !
-      wslp2(:,:,1) = 0._wp                ! force the surface wslp to zero
-
-      CALL crs_lbc_lnk( wslp2, 'W', 1. )      ! lateral boundary confition on wslp2 only   ==>>> gm : necessary ? to be checked
-      !
-      CALL wrk_dealloc( jpi,jpj, z1_mlbw )
-      CALL wrk_dealloc( jpi,jpj,jpk, zalbet )
-      CALL wrk_dealloc( jpi,jpj,jpk,2, zdxrho , zdyrho, zdzrho,              klstart = 0  )
-      CALL wrk_dealloc( jpi,jpj,  2,2, zti_mlb, ztj_mlb,        kkstart = 0, klstart = 0  )
-      !
-      IF( nn_timing == 1 )  CALL timing_stop('ldf_slp_grif')
-      !
-   END SUBROUTINE ldf_slp_grif_crs
-
 
    SUBROUTINE ldf_slp_mxl_crs( prd, pn2, p_gru, p_grv, p_dzr )
@@ -657,18 +383,13 @@
       zm1_2g = -0.5_wp / grav
       !
-      uslpml (1,:) = 0._wp      ;      uslpml (jpi,:) = 0._wp
-      vslpml (1,:) = 0._wp      ;      vslpml (jpi,:) = 0._wp
-      wslpiml(1,:) = 0._wp      ;      wslpiml(jpi,:) = 0._wp
-      wslpjml(1,:) = 0._wp      ;      wslpjml(jpi,:) = 0._wp
+      uslpml (1,:) = 0._wp      ;      uslpml (jpi_crs,:) = 0._wp
+      vslpml (1,:) = 0._wp      ;      vslpml (jpi_crs,:) = 0._wp
+      wslpiml(1,:) = 0._wp      ;      wslpiml(jpi_crs,:) = 0._wp
+      wslpjml(1,:) = 0._wp      ;      wslpjml(jpi_crs,:) = 0._wp
       !
       !                                            !==   surface mixed layer mask   !
       DO jk = 1, jpk                               ! =1 inside the mixed layer, =0 otherwise
-# if defined key_vectopt_loop
-         DO jj = 1, 1
-            DO ji = 1, jpij                        ! vector opt. (forced unrolling)
-# else
-         DO jj = 1, jpj
-            DO ji = 1, jpi
-# endif
+         DO jj = 1, jpj_crs
+            DO ji = 1, jpi_crs
                ik = nmln_crs(ji,jj) - 1
                IF( jk <= ik ) THEN   ;   omlmask(ji,jj,jk) = 1._wp
@@ -690,11 +411,6 @@
       !-----------------------------------------------------------------------
       !
-# if defined key_vectopt_loop
-      DO jj = 1, 1
-         DO ji = jpi+2, jpij-jpi-1   ! vector opt. (forced unrolling)
-# else
-      DO jj = 2, jpjm1
-         DO ji = 2, jpim1
-# endif
+      DO jj = 2, jpj_crsm1
+         DO ji = 2, jpi_crsm1
             !                        !==   Slope at u- & v-points just below the Mixed Layer   ==!
             !
@@ -744,13 +460,4 @@
       !
       IF( nn_timing == 1 )  CALL timing_stop('ldf_slp_mxl')
- !     WRITE(numout,*) ' uslp_crs' , MAXVAL(uslp_crs(:,:,:)) , MINVAL(uslp_crs(:,:,:))
- !     WRITE(numout,*) ' vslp_crs' , vslp_crs
- !     WRITE(numout,*) ' uslpml' , uslpml
- !     WRITE(numout,*) ' vslpml' , vslpml
- !     WRITE(numout,*) ' wslpiml' , wslpiml
- !     WRITE(numout,*) ' wslpjml' , wslpjml
-  !    WRITE(numout,*) ' wslpi_crs' , wslpi_crs(:,:,2)
-  !    WRITE(numout,*) ' wslpj_crs_mxl' , wslpj_crs(:,:,:)
-      
       !
    END SUBROUTINE ldf_slp_mxl_crs
@@ -774,11 +481,11 @@
       IF(lwp) THEN
          WRITE(numout,*)
-         WRITE(numout,*) 'ldf_slp_init : direction of lateral mixing'
+         WRITE(numout,*) 'ldf_slp_init_crs : direction of lateral mixing'
          WRITE(numout,*) '~~~~~~~~~~~~'
       ENDIF
 
       IF( ln_traldf_grif ) THEN        ! Griffies operator : triad of slopes
-         ALLOCATE( triadi_g(jpi,jpj,jpk,0:1,0:1) , triadj_g(jpi,jpj,jpk,0:1,0:1) , wslp2(jpi,jpj,jpk) , STAT=ierr )
-         ALLOCATE( triadi  (jpi,jpj,jpk,0:1,0:1) , triadj  (jpi,jpj,jpk,0:1,0:1)                      , STAT=ierr )
+         ALLOCATE( triadi_g(jpi_crs,jpj_crs,jpk,0:1,0:1) , triadj_g(jpi_crs,jpj_crs,jpk,0:1,0:1) , wslp2(jpi_crs,jpj_crs,jpk) , STAT=ierr )
+         ALLOCATE( triadi  (jpi_crs,jpj_crs,jpk,0:1,0:1) , triadj  (jpi_crs,jpj_crs,jpk,0:1,0:1)                      , STAT=ierr )
          IF( ierr > 0             )   CALL ctl_stop( 'STOP', 'ldf_slp_init : unable to allocate Griffies operator slope' )
          !
